//MyHash.h
//Fowler - Noll - Vo (FNV)  ؽ : http://isthe.com/chongo/tech/comp/fnv/

#ifndef _MYHASH_H
#define _MYHASH_H

#include "types.h"

class MyHash
{
public:
	MyHash();
	MyHash(uint32 hashValue);
	MyHash(const char *pString);
	MyHash(const MyHash &rhs);
	MyHash &operator=(const MyHash &rhs);

	void Set(const uint32 hash);

	bool IsValid() const;
	operator unsigned int()			{ return m_hashValue; }

	const bool operator<(const MyHash &rhs) const;
	const bool operator>(const MyHash &rhs) const;
	const bool operator<=(const MyHash &rhs) const;
	const bool operator>=(const MyHash &rhs) const;
	const bool operator==(const MyHash &rhs) const;
	const bool operator!=(const MyHash &rhs) const;
private:
	uint32 MakeHash(const char *pString);

private:
	uint32 m_hashValue;
};

#endif