//MyPropertySystem.cpp

#include "stdafx.h"
#include "MyPropertySystem.h"


MyPropertySystem::~MyPropertySystem()
{
	{
		PropertyList::iterator it = m_properties.begin();
		PropertyList::iterator end = m_properties.end();
		for( ; it != end; ++it )
		{
			IProperty* prop = (*it);
			delete prop;
		}
		m_properties.clear();
	}
}
//-------------------------------------------------------------------------------------------------------
IProperty* MyPropertySystem::GetProperty( const std::string& name )
{
	PropertyList::iterator it = m_properties.begin();
	while( it != m_properties.end() )
	{
		if( name.compare((*it)->GetName()) == 0 )
		{
			IProperty* prop = (IProperty*)(*it);
			return prop;
		}
		++it;
	}
	return NULL;
}