//HealthComponent.h

#ifndef HEALTHCOMPONENT_H
#define HEALTHCOMPONENT_H

#include "MyComponent.h"

class IProperty;
class MyEntity;

class HealthComponent : public MyComponent
{
public:
	HealthComponent( MyEntity* entity, MyEntityManager* manager );
	virtual		~HealthComponent();
	void		Update( int timeDiff );

protected:
	int&		m_health;
	void		ReceiveDamage( IProperty* property, MyEntity* sender );
};


#endif