// mian.cpp : ܼ  α׷   մϴ.
//

//1 MyProperty ׽Ʈ
//2 MyEntity ۼ (MyEntityManager, MyComponent ⸸ ۼ)
//3 Component Factory ۼ
  //4 MyComponet Ŭ ä
//5 MyProperty MyEntity ߰
//6 MyEventDispatcher ä  - Effective Event Handling in C++
//  http://www.gamedev.net/reference/articles/article2459.asp
//7 MyEventDispatcher ׽Ʈ  HealthCompnent Ŭ ۼ

#include "stdafx.h"
#include <iostream>

#include "MyProperty.h"
#include "MyEntityType.h"
#include "MyEntity.h"
#include "MyProperty.h"
#include "MyComponentFactory.h"
#include "MyComponent.h"
#include "healthcomponent.h"
#include "MyStageManager.h"
#include "MyEntityManager.h"

// Player ׽Ʈ
#include "Player.h"

//SimpleGraphic MyComponetFactory ׽Ʈϱ ؼ ʿ
class SimpleGraphic : public MyComponent
{
public: 
	SimpleGraphic( MyEntity* entity, MyEntityManager* manager ) :
	  MyComponent( entity, manager, "SimpleGraphic" )
	{
	}
	virtual		~SimpleGraphic()
	{
	}
	virtual void Update( int timeDiff )
	{
	
	}

};


int _tmain(int argc, _TCHAR* argv[])
{
	//1 MyProperty ׽Ʈ
    MyProperty<float>* pValue = new MyProperty<float>("testValue");
	pValue->GetValue() = 3.03f;
	std::cout << pValue->GetName() << "=" << pValue->GetValue() << std::endl;
	const char* szType = pValue->GetTypeName();  //float 

	//3 Component Factory ۼ
	MyComponentFactory* pComponentFactory = 
		new MySimpleComponentFactory<SimpleGraphic>( component_uid("SimpleGraphic") );
	delete pComponentFactory;

	//-------------------------------Helath Component  ׽Ʈ begin ---------------------------------------
	MyStageManager* manager = new MyStageManager();
	//RegisterStage();
	MyEntityManager* entityManager = new MyEntityManager( manager );
	entityManager->RegisterComponent(new MySimpleComponentFactory<HealthComponent>(component_uid("HealthComponent")));

	MyEntity* enemyTest = entityManager->CreateEntity( component_uid("Enemy") );
	enemyTest->AddComponent( component_uid("HealthComponent") );
	MyComponent* component = enemyTest->GetComponent( component_uid("HealthComponent") );
	component->GetPropertyValue<int>( "Health" ) = 100;
	enemyTest->Update( 1 );

	//-------------------------------Helath Component  ׽Ʈ end ---------------------------------------


	//------------------------------- Player ׽Ʈ begin---------------------------------------
	//HelathComponent EnemyKilled ޼ ó
	Player* player = new Player( manager, entityManager );
	player->Init();
	component->GetPropertyValue<int>("Health") = 0;
	component->Update( 1 );

	delete player;
	//------------------------------- Player ׽Ʈ end ---------------------------------------

	delete manager;
	delete entityManager;
	return 0;
}

