//player.h
#ifndef _PLAYER_H

class IProperty;
class MyEntity;
class MyStageManager;
class MyEntityManager;

class Player
{
public:
	Player( MyStageManager* manager, MyEntityManager* entitymanager );
	virtual ~Player();

	void	Init();
	void	Update( int timeDiff );

protected:
	MyStageManager*  m_pStageManager;
	MyEntityManager* m_pEntityManager;
	int		m_money;

	//events
	void	EnemyKilled( IProperty* property, MyEntity* sender );
};

#endif