//MyComponent.h

#ifndef _MYCOMPONENT_H
#define _MYCOMPONENT_H

#include "MyEntity.h"

class MyEntityManager;


class MyComponent : public MyPropertySystem
{
	MyDeclareRTTI;

public:
	MyComponent( MyEntity* entity, MyEntityManager* manager, component_uid uid );
	virtual	~MyComponent();

	MyEntity*		GetOwner();
	virtual void	Update( int timeDiff ) = 0;

	/*
	template<typename T>
	T& GetPropertyValue( const std::string& name )
	{
		if( m_pOwner )
			return m_pOwner->GetPropertyValue<T>( name );
		exit(1);
	}
	template<typename T>
	MyProperty<T>* GetProperty( const std::string& name )
	{
		if( m_pOwner )
			return m_pOwner->GetProperty<T>(name);
	}
	*/

protected:
	component_uid		m_uid;
	MyEntity*			m_pOwner;
	MyEntityManager*	m_pManager;
};

#endif