//MyStageFactory.h

#ifndef _MySTAGEFACTORY_H
#define _MySTAGEFACTORY_H

class MyStage;
class MyStageManager;

class MyStageFactory
{
public:
	MyStageFactory( std::string& name )
	{
		m_name = name;
	}
	MyStageFactory( const MyStageFactory& factory )
	{
		m_name = factory.m_name;
	}
	virtual MyStage* CreateStage( MyStageManager* manager )
	{
		return NULL;
	}
	virtual ~MyStageFactory()
	{
	}
	std::string m_name;
};

template< class T >
class MySimpleStageFactory : public MyStageFactory
{
public:
	MySimpleStageFactory( std::string& name ) : MyStageFacory( name )
	{
	}
	virtual MyStage* CreateStage( MyStageManager* manager )
	{
		return new T( manager );
	}
};


#endif